// tslint:disable-next-line:no-reference
/// <reference path="../../node_modules/@types/jasmine/index.d.ts" />

import { Result } from "../../src/util/result";
import { PabPuissance, PabPuissanceParams } from "../../src/pab/pab_puissance";
import { checkResult } from "../test_func";

function PabPuissanceTest(varTest: string) {
    describe("Calc(): ", () => {
        it("V should be 1", () => {
            const prms = new PabPuissanceParams(
                0.3,      // Chute entre bassins DH (m)
                0.1,      // Débit Q (m3/s)
                0.5,    // Volume V (m3)
                588.6   // Puissance dissipée Pv (W/m3)
            );

            let res: number = prms[varTest].v;

            const nub = new PabPuissance(prms);
            prms[varTest].v = undefined;

            checkResult(nub.Calc(varTest, 1e-9), res);
        });
    });
}

describe("Class PabPuissance: ", () => {
    // beforeEach(() => {
    // });
    // beforeAll(() => {
    // });
    PabPuissanceTest("DH");
    PabPuissanceTest("Q");
    PabPuissanceTest("V");
    PabPuissanceTest("Pv");
});
