import { CourbeRemous, CourbeRemousParams, MethodeResolution } from "../../src/remous";
import { cSnRectang, ParamsSectionRectang } from "../../src/section/section_rectang";
import { cLog } from "../../src/util/log";
import { Message, MessageCode } from "../../src/util/message";
import { compareArray, compareLog, compareObject } from "../test_func";
import { precDist } from "../test_config";
import { Result } from "../../src/util/result";

describe("Class Remous / section rectangulaire :", () => {
    describe("méthode Euler explicite :", () => {
        // it("faible pente, ressaut avant l'amont (1)", () => {
        //     // cas non reproductible (fluvial =~ 17 sur toute la longueur du canal)
        //     let prms = new ParamsSectionRectang(undefined, // tirant d'eau
        //         2.5, // largeur de fond
        //         40, //  Ks=Strickler
        //         2, // Q=Débit
        //         0.001, // If=pente du fond
        //         precDist, // précision
        //         1 // YB=hauteur de berge
        //     );

        //     let sect = new cSnRectang(undefined, prms);

        //     let prem = new CourbeRemousParams(sect, 0.3, // Yamont = tirant amont
        //         0.403, // Yaval = tirant aval
        //         100,  // Long= Longueur du bief
        //         5,  // Dx=Pas d'espace
        //         MethodeResolution.EulerExplicite
        //     );

        //     let log = new cLog();
        //     let rem = new CourbeRemous(sect, prem, log);

        //     let res = rem.calculRemous(undefined);

        //     // données de validation : version Typescript (Oct 2017) méthode des trapèzes

        //     let f = {
        //      "0": 0.7554999999999994, "5": 0.7497499999999995, "10": 0.7439999999999996, "15": 0.7377499999999996,
        //      "20": 0.7314999999999996, "25": 0.7247499999999997, "30": 0.7174999999999997, "35": 0.7097499999999998,
        //      "40": 0.7014999999999998, "45": 0.6927499999999999, "50": 0.6834999999999999, "55": 0.6732499999999999,
        //      "60": 0.6619999999999999, "65": 0.6497499999999999, "70": 0.6365, "75": 0.62125, "80": 0.604,
        //      "85": 0.58325, "90": 0.558, "95": 0.52375, "100": 0.403 };
        //     compareObject("Yfluvial", res["flu"], f, 0.03);

        //     let t = {};
        //     compareObject("Ytorrentiel", res["tor"], t, 0.03);

        //     let x = [0, 5, 10, 15, 20, 25, 30, 35, 40, 45, 50, 55, 60, 65, 70, 75, 80, 85, 90, 95, 100];
        //     compareArray("abscisses", res["trX"], x);

        //     let expLog = new cLog();
        //     let m = new ErrorMessage(ErrorCode.ERROR_REMOUS_LARGEUR_BERGE);
        //     m.extraVar["B"] = 2.5;
        //     expLog.add(m);

        //     m = new ErrorMessage(ErrorCode.ERROR_REMOUS_H_CRITIQUE);
        //     m.extraVar["Yc"] = 0.403;
        //     expLog.add(m);

        //     m = new ErrorMessage(ErrorCode.ERROR_REMOUS_H_NORMALE);
        //     m.extraVar["Yn"] = 0.953;
        //     expLog.add(m);

        //     expLog.add(new ErrorMessage(ErrorCode.ERROR_REMOUS_CALCUL_FLUVIAL));

        //     m = new ErrorMessage(ErrorCode.ERROR_REMOUS_PENTE_FORTE);
        //     m.extraVar["x"] = 95;
        //     expLog.add(m);

        //     expLog.add(new ErrorMessage(ErrorCode.ERROR_REMOUS_CALCUL_TORRENTIEL));

        //     m = new ErrorMessage(ErrorCode.WARNING_REMOUS_ARRET_CRITIQUE)
        //     m.extraVar["x"] = 10;
        //     expLog.add(m);

        //     m = new ErrorMessage(ErrorCode.ERROR_REMOUS_RESSAUT_DEHORS);
        //     m.extraVar["sens"] = "amont";
        //     m.extraVar["x"] = 0;
        //     expLog.add(m);

        //     compareLog(log, expLog);
        // });

        // it("faible pente, ressaut (1 point) à l'intérieur du bief", () => {
        //     // cas non reproductible (fluvial =~ 17 sur toute la longueur du canal)

        //     let prms = new ParamsSectionRectang(undefined, // tirant d'eau
        //         2.5, // largeur de fond
        //         40, //  Ks=Strickler
        //         2, // Q=Débit
        //         0.001, // If=pente du fond
        //         precDist, // précision
        //         1 // YB=hauteur de berge
        //     );

        //     let sect = new cSnRectang(undefined, prms);

        //     let prem = new CourbeRemousParams(sect, 0.15, // Yamont = tirant amont
        //         0.403, // Yaval = tirant aval
        //         100,  // Long= Longueur du bief
        //         5,  // Dx=Pas d'espace
        //         MethodeResolution.EulerExplicite
        //     );

        //     let log = new cLog();
        //     let rem = new CourbeRemous(sect, prem, log);

        //     let res = rem.calculRemous(undefined);

        //     // données de validation : version Typescript (Oct 2017) méthode des trapèzes

        //     let f = {
        //      "0": 0.15, "5": 0.7497499999999995, "10": 0.7439999999999996, "15": 0.7377499999999996,
        //      "20": 0.7314999999999996, "25": 0.7247499999999997, "30": 0.7174999999999997,
        //      "35": 0.7097499999999998, "40": 0.7014999999999998, "45": 0.6927499999999999,
        //      "50": 0.6834999999999999, "55": 0.6732499999999999, "60": 0.6619999999999999,
        //      "65": 0.6497499999999999, "70": 0.6365, "75": 0.62125, "80": 0.604, "85": 0.58325,
        //      "90": 0.558, "95": 0.52375, "100": 0.403 };
        //     compareObject("Yfluvial", res["flu"], f, 0.03);

        //     let t = { "0": 0.15, "5": 0.7497499999999995 };
        //     compareObject("Ytorrentiel", res["tor"], t, 0.03);

        //     let x = [0, 5, 10, 15, 20, 25, 30, 35, 40, 45, 50, 55, 60, 65, 70, 75, 80, 85, 90, 95, 100];
        //     compareArray("abscisses", res["trX"], x);

        //     let expLog = new cLog();
        //     let m = new ErrorMessage(ErrorCode.ERROR_REMOUS_LARGEUR_BERGE);
        //     m.extraVar["B"] = 2.5;
        //     expLog.add(m);

        //     m = new ErrorMessage(ErrorCode.ERROR_REMOUS_H_CRITIQUE);
        //     m.extraVar["Yc"] = 0.403;
        //     expLog.add(m);

        //     m = new ErrorMessage(ErrorCode.ERROR_REMOUS_H_NORMALE);
        //     m.extraVar["Yn"] = 0.953;
        //     expLog.add(m);

        //     expLog.add(new ErrorMessage(ErrorCode.ERROR_REMOUS_CALCUL_FLUVIAL));

        //     m = new ErrorMessage(ErrorCode.ERROR_REMOUS_PENTE_FORTE);
        //     m.extraVar["x"] = 95;
        //     expLog.add(m);

        //     expLog.add(new ErrorMessage(ErrorCode.ERROR_REMOUS_CALCUL_TORRENTIEL));

        //     m = new ErrorMessage(ErrorCode.WARNING_REMOUS_ARRET_CRITIQUE)
        //     m.extraVar["x"] = 20;
        //     expLog.add(m);

        //     m = new ErrorMessage(ErrorCode.ERROR_REMOUS_RESSAUT_DEHORS);
        //     m.extraVar["sens"] = "amont";
        //     m.extraVar["x"] = 0;
        //     expLog.add(m);

        //     compareLog(log, expLog);
        // });

        // it("faible pente, ressaut (plusieurs points) à l'intérieur du bief (1)", () => {
        //     let prms = new ParamsSectionRectang(undefined, // tirant d'eau
        //         2.5, // largeur de fond
        //         40, //  Ks=Strickler
        //         2, // Q=Débit
        //         0.001, // If=pente du fond
        //         precDist, // précision
        //         1 // YB=hauteur de berge
        //     );

        //     let sect = new cSnRectang(undefined, prms);

        //     let prem = new CourbeRemousParams(sect, 0.01, // Yamont = tirant amont
        //         0.403, // Yaval = tirant aval
        //         5,  // Long= Longueur du bief
        //         0.05,  // Dx=Pas d'espace
        //         MethodeResolution.EulerExplicite
        //     );

        //     let log = new cLog();
        //     let rem = new CourbeRemous(sect, prem, log);

        //     let res = rem.calculRemous(undefined);

        //     // données de validation : version Typescript (Oct 2017) méthode des trapèzes

        //     let f = { "0": 0.01, "1": 0.5005000000000004, "2": 0.4885000000000004, "3": 0.47393750000000023, "4": 0.45418750000000013, "5": 0.403, "4.95": 0.41471875, "4.9": 0.41956250000000006, "4.85": 0.42328125000000005, "4.8": 0.42637500000000006, "4.75": 0.42909375000000005, "4.7": 0.43156250000000007, "4.65": 0.43378125000000006, "4.6": 0.43587500000000007, "4.55": 0.4378437500000001, "4.5": 0.4396875000000001, "4.45": 0.4414062500000001, "4.4": 0.44306250000000014, "4.35": 0.44465625000000014, "4.3": 0.4461875000000001, "4.25": 0.44765625000000014, "4.2": 0.44906250000000014, "4.15": 0.4504062500000001, "4.1": 0.45168750000000013, "4.05": 0.45296875000000014, "3.95": 0.4554062500000001, "3.9": 0.4565625000000001, "3.85": 0.45771875000000006, "3.8": 0.45881250000000007, "3.75": 0.45990625000000007, "3.7": 0.4610000000000001, "3.65": 0.46203125000000006, "3.6": 0.46306250000000004, "3.55": 0.46403125000000006, "3.5": 0.4650000000000001, "3.45": 0.4659687500000001, "3.4": 0.4669375000000001, "3.35": 0.4678437500000001, "3.3": 0.4687500000000001, "3.25": 0.4696562500000001, "3.2": 0.4705625000000001, "3.15": 0.47140625000000014, "3.1": 0.47225000000000017, "3.05": 0.4730937500000002, "2.95": 0.47478125000000027, "2.9": 0.4755625000000003, "2.85": 0.4763437500000003, "2.8": 0.4771250000000003, "2.75": 0.4779062500000003, "2.7": 0.4786875000000003, "2.65": 0.47946875000000033, "2.6": 0.4801875000000003, "2.55": 0.4809062500000003, "2.5": 0.4816250000000003, "2.45": 0.4823437500000003, "2.4": 0.4830625000000003, "2.35": 0.4837812500000003, "2.3": 0.48450000000000026, "2.25": 0.48521875000000025, "2.2": 0.4858750000000003, "2.15": 0.4865312500000003, "2.1": 0.48718750000000033, "2.05": 0.48784375000000035, "1.95": 0.4891562500000004, "1.9": 0.48981250000000043, "1.85": 0.49046875000000045, "1.8": 0.4911250000000005, "1.75": 0.4917812500000005, "1.7": 0.4923750000000005, "1.65": 0.4929687500000005, "1.6": 0.4935625000000005, "1.55": 0.4941562500000005, "1.5": 0.4947500000000005, "1.45": 0.4953437500000005, "1.4": 0.49593750000000053, "1.35": 0.49653125000000053, "1.3": 0.49712500000000054, "1.25": 0.49771875000000054, "1.2": 0.49831250000000055, "1.15": 0.49890625000000055, "1.1": 0.49943750000000053, "1.05": 0.4999687500000005, "0.95": 0.5010312500000003, "0.9": 0.5015625000000001, "0.85": 0.50209375, "0.8": 0.5026249999999999, "0.75": 0.5031562499999997, "0.7": 0.5036874999999996, "0.65": 0.5042187499999995, "0.6": 0.5047499999999994, "0.55": 0.5052812499999992, "0.5": 0.5058124999999991, "0.45": 0.506343749999999, "0.4": 0.5068749999999989, "0.35": 0.5074062499999987, "0.3": 0.5079374999999986, "0.25": 0.5084062499999986, "0.2": 0.5088749999999986, "0.15": 0.5093437499999987, "0.1": 0.5098124999999987, "0.05": 0.5102812499999987 };
        //     compareObject("Yfluvial", res["flu"], f, 0.03);

        //     let t = { "0": 0.01, "0.05": 0.01146875, "0.1": 0.012812500000000001, "0.15": 0.014156250000000002, "0.2": 0.015437500000000003, "0.25": 0.01665625, "0.3": 0.017875, "0.35": 0.019093749999999996, "0.4": 0.020249999999999994, "0.45": 0.02140624999999999, "0.5": 0.02249999999999999, "0.55": 0.023593749999999986, "0.6": 0.024687499999999984, "0.65": 0.02578124999999998, "0.7": 0.02681249999999998, "0.75": 0.027843749999999976, "0.8": 0.028874999999999974, "0.85": 0.02990624999999997, "0.9": 0.5015625000000001 };
        //     compareObject("Ytorrentiel", res["tor"], t, 0.03);

        //     let x = [0, 0.05, 0.1, 0.15, 0.2, 0.25, 0.3, 0.35, 0.4, 0.45, 0.5, 0.55, 0.6, 0.65, 0.7, 0.75, 0.8, 0.85, 0.9, 0.95, 1, 1.05, 1.1, 1.15, 1.2, 1.25, 1.3, 1.35, 1.4, 1.45, 1.5, 1.55, 1.6, 1.65, 1.7, 1.75, 1.8, 1.85, 1.9, 1.95, 2, 2.05, 2.1, 2.15, 2.2, 2.25, 2.3, 2.35, 2.4, 2.45, 2.5, 2.55, 2.6, 2.65, 2.7, 2.75, 2.8, 2.85, 2.9, 2.95, 3, 3.05, 3.1, 3.15, 3.2, 3.25, 3.3, 3.35, 3.4, 3.45, 3.5, 3.55, 3.6, 3.65, 3.7, 3.75, 3.8, 3.85, 3.9, 3.95, 4, 4.05, 4.1, 4.15, 4.2, 4.25, 4.3, 4.35, 4.4, 4.45, 4.5, 4.55, 4.6, 4.65, 4.7, 4.75, 4.8, 4.85, 4.9, 4.95, 5];
        //     compareArray("abscisses", res["trX"], x);

        //     let expLog = new cLog();
        //     let m = new ErrorMessage(ErrorCode.ERROR_REMOUS_LARGEUR_BERGE);
        //     m.extraVar["B"] = 2.5;
        //     expLog.add(m);

        //     m = new ErrorMessage(ErrorCode.ERROR_REMOUS_H_CRITIQUE);
        //     m.extraVar["Yc"] = 0.403;
        //     expLog.add(m);

        //     m = new ErrorMessage(ErrorCode.ERROR_REMOUS_H_NORMALE);
        //     m.extraVar["Yn"] = 0.953;
        //     expLog.add(m);

        //     expLog.add(new ErrorMessage(ErrorCode.ERROR_REMOUS_CALCUL_FLUVIAL));

        //     m = new ErrorMessage(ErrorCode.ERROR_REMOUS_PENTE_FORTE);
        //     m.extraVar["x"] = 4.75;
        //     expLog.add(m);

        //     expLog.add(new ErrorMessage(ErrorCode.ERROR_REMOUS_CALCUL_TORRENTIEL));

        //     m = new ErrorMessage(ErrorCode.ERROR_REMOUS_RESSAUT_DEHORS);
        //     m.extraVar["sens"] = "amont";
        //     m.extraVar["x"] = 0;
        //     expLog.add(m);
        // });

        it("faible pente, pas de ressaut, Yamont > Yc, Yaval > Yn", () => {
            let prms = new ParamsSectionRectang(undefined, // tirant d'eau
                2.5, // largeur de fond
                40, //  Ks=Strickler
                2, // Q=Débit
                0.001, // If=pente du fond
                precDist, // précision
                1 // YB=hauteur de berge
            );

            let sect = new cSnRectang(prms);

            let prem = new CourbeRemousParams(sect, 0.5, // Yamont = tirant amont
                1, // Yaval = tirant aval
                100,  // Long= Longueur du bief
                5,  // Dx=Pas d'espace
                MethodeResolution.EulerExplicite
            );

            let rem = new CourbeRemous(prem);

            let res: Result = rem.calculRemous(undefined);

            // données de validation : version Typescript (Oct 2017) méthode des trapèzes

            let f = { "0": 0.9872500000000014, "5": 0.9872500000000014, "10": 0.9872500000000014, "15": 0.9872500000000014, "20": 0.9880000000000013, "25": 0.9887500000000012, "30": 0.9895000000000012, "35": 0.9902500000000011, "40": 0.991000000000001, "45": 0.9917500000000009, "50": 0.9925000000000008, "55": 0.9932500000000007, "60": 0.9940000000000007, "65": 0.9947500000000006, "70": 0.9955000000000005, "75": 0.9962500000000004, "80": 0.9970000000000003, "85": 0.9977500000000002, "90": 0.9985000000000002, "95": 0.9992500000000001, "100": 1 };
            compareObject("Yfluvial", res.getExtraResult("flu"), f, 0.03);

            expect(res.extraResultLength("tor") == 0).toBeTruthy("la ligne d'eau torrentielle ne devrait comporter aucune valeur");

            let x = [0, 5, 10, 15, 20, 25, 30, 35, 40, 45, 50, 55, 60, 65, 70, 75, 80, 85, 90, 95, 100];
            compareArray("abscisses", res.getExtraResult("trX"), x);

            let expLog = new cLog();
            let m = new Message(MessageCode.INFO_REMOUS_LARGEUR_BERGE);
            m.extraVar["B"] = 2.5;
            expLog.add(m);

            m = new Message(MessageCode.INFO_REMOUS_H_CRITIQUE);
            m.extraVar["Yc"] = 0.403;
            expLog.add(m);

            m = new Message(MessageCode.INFO_REMOUS_H_NORMALE);
            m.extraVar["Yn"] = 0.953;
            expLog.add(m);

            expLog.add(new Message(MessageCode.INFO_REMOUS_CALCUL_FLUVIAL));

            expLog.add(new Message(MessageCode.ERROR_REMOUS_PAS_CALCUL_DEPUIS_AMONT));

            compareLog(res.globalLog, expLog);
        });

        it("faible pente, pas de ressaut, Yamont > Yc, Yc < Yaval < Yn", () => {
            let prms = new ParamsSectionRectang(undefined, // tirant d'eau
                2.5, // largeur de fond
                40, //  Ks=Strickler
                2, // Q=Débit
                0.001, // If=pente du fond
                precDist, // précision
                1 // YB=hauteur de berge
            );

            let sect = new cSnRectang(prms);

            let prem = new CourbeRemousParams(sect, 0.5, // Yamont = tirant amont
                0.7, // Yaval = tirant aval
                100,  // Long= Longueur du bief
                5,  // Dx=Pas d'espace
                MethodeResolution.EulerExplicite
            );

            let rem = new CourbeRemous(prem);

            let res = rem.calculRemous(undefined);

            // données de validation : version Typescript (Oct 2017) méthode trapèzes

            let f = { "0": 0.805499999999999, "5": 0.802249999999999, "10": 0.7984999999999991, "15": 0.7947499999999992, "20": 0.7909999999999993, "25": 0.7867499999999993, "30": 0.7824999999999993, "35": 0.7782499999999993, "40": 0.7739999999999994, "45": 0.7692499999999994, "50": 0.7644999999999995, "55": 0.7592499999999995, "60": 0.7539999999999996, "65": 0.7482499999999996, "70": 0.7424999999999997, "75": 0.7362499999999997, "80": 0.7299999999999998, "85": 0.7232499999999998, "90": 0.7159999999999999, "95": 0.7082499999999999, "100": 0.7 };
            compareObject("Yfluvial", res.getExtraResult("flu"), f, 0.03);

            expect(res.extraResultLength("tor") == 0).toBeTruthy("la ligne d'eau torrentielle ne devrait comporter aucune valeur");

            let x = [0, 5, 10, 15, 20, 25, 30, 35, 40, 45, 50, 55, 60, 65, 70, 75, 80, 85, 90, 95, 100];
            compareArray("abscisses", res.getExtraResult("trX"), x);

            let expLog = new cLog();
            let m = new Message(MessageCode.INFO_REMOUS_LARGEUR_BERGE);
            m.extraVar["B"] = 2.5;
            expLog.add(m);

            m = new Message(MessageCode.INFO_REMOUS_H_CRITIQUE);
            m.extraVar["Yc"] = 0.403;
            expLog.add(m);

            m = new Message(MessageCode.INFO_REMOUS_H_NORMALE);
            m.extraVar["Yn"] = 0.953;
            expLog.add(m);

            expLog.add(new Message(MessageCode.INFO_REMOUS_CALCUL_FLUVIAL));

            expLog.add(new Message(MessageCode.ERROR_REMOUS_PAS_CALCUL_DEPUIS_AMONT));

            compareLog(res.globalLog, expLog);
        });
    });
});
