import { Structure, StructureParams } from "../../src/structure/structure";
import { Result } from "../../src/util/result";

class StructureTest extends Structure {

    constructor(prms: StructureParams, dbg: boolean = false) {
        super(prms, dbg);
    }

    /**
     * Test of getFlowMode
     */
    public testGetFlowMode() {
        this.prms.update_h1h2();
        return this.getFlowMode();
    }

    /**
     * Test of getFlowRegime
     */
    public testGetFlowRegime() {
        this.prms.update_h1h2();
        return this.getFlowRegime();
    }

    public Equation(sVarCalc: string): Result {
        this.prms.update_h1h2();
        Structure.CheckEquation(sVarCalc);
        const data = this.getResultData();

        return new Result(this.prms.Z1.v - this.prms.Z2.v, data);
    }

}

/* Test structure with :
 *  - ZDV = 0
 *  - Z1 = 30
 *  - Z2 = 15
 *  - expected Q = 15
 */
export const structTestPrm: StructureParams = new StructureParams(1, 0, 30, 15);
export const structTest: StructureTest = new StructureTest(structTestPrm, false);
