/**
 * Série de valeurs à calculer définie par le nom de la variable à sérier et le vecteur de valeur
 */
export class Serie {
    public name: string;
    public values: number[];

    constructor(name: string, values: number[]) {
        this.name = name;
        this.values = values;
    }
}

/**
 * Gestion des messages de debogage dans la console
 * @note Etendre cette classe pour toutes les classes à debugguer
 * Dans le constructeur, utiliser super(true) pour debugger la classe, super(false) sinon.
 */
// tslint:disable-next-line:max-classes-per-file
export abstract class Debug {
    /**
     * @param _DBG Flag de débuggage
     */
    constructor(private _DBG: boolean) { }

    /**
     * Affiche un message dans la console si le flag this.DBG est à true
     * @param s Message à afficher dans la console
     */
    public debug(s: any) {
        // tslint:disable-next-line:no-console
        if (this._DBG) { console.log(s); }
    }

    get DBG() { return this._DBG; }
}

/**
 * Méthode simulant l'opérateur booléen xor
 * @see http://www.howtocreate.co.uk/xor.html
 */
export function XOR(a: boolean, b: boolean): boolean {
    return (a || b) && !(a && b);
}

/**
 * Méthode simulant l'opérateur booléen identité (vrai si a=b)
 */
export function BoolIdentity(a: boolean, b: boolean): boolean {
    return (a && b) || (!a && !b);
}

/**
 * arrondi d'un nombre avec une précision donnée
 * @param val nombre à arrondir
 * @param prec nombre de chiffres
 */
export function round(val: number, prec: number) {
    const m = Math.pow(10, prec || 0);
    return Math.round(val * m) / m;
}
